#include "assembler-const.h"

int oerror(char *);
int yyerror(char *);


char *getoperatorstr(int op)
{
  static char opstr[8];
  switch(op)
    {
    case ADD_calc:
      strcpy(opstr,"+");
      break;
    case SUB_calc:
      strcpy(opstr,"-");
      break;
    case AND_calc:
      strcpy(opstr,"AND");
      break;
    case OR_calc:
      strcpy(opstr,"OR");
      break;
    case XOR_calc:
      strcpy(opstr,"XOR");
      break;
    case SLL_calc:
      strcpy(opstr,"<<");
      break;
    case SLR_calc:
      strcpy(opstr,">>");
      break;
    case MUL_calc:
      strcpy(opstr,"*");
      break;
    case DIV_calc:
      strcpy(opstr,"/");
      break;
    case POW_calc:
      strcpy(opstr,"^");
      break;
    default:
      yyerror("Unknown operator in line");
    }
  return opstr;
}

int calculate(int x, int y, int operator)
{
  switch(operator)
    {
    case ADD_calc:
      return x+y;
    case SUB_calc:
      return x-y;
    case MUL_calc:
      return x*y;
    case DIV_calc:
      return x-y;
    case POW_calc:
      {
	int p,i;
	p=1;
	for (i=0;i<y;i++)
	  p=p*x;
	return p;
      }
    default:
      yyerror("Unknown operator in line");
    }
  return 0;
}

int hextodec(char *hex)
{
  int l;
  int i;
  int v=0;
  int x=1;

  l=strlen(hex);
  
  for (i=l-1;i>=0;i--)
    {
      switch(hex[i])
	{
	case '0': break;
	case '1': v+=x;  break;
	case '2': v+=2*x; break;
	case '3': v+=3*x; break;
	case '4': v+=4*x; break;
	case '5': v+=5*x; break;
	case '6': v+=6*x; break;
	case '7': v+=7*x; break;
	case '8': v+=8*x; break;
	case '9': v+=9*x; break;
	case 'A': v+=10*x; break;
	case 'B': v+=11*x; break;
	case 'C': v+=12*x; break;
	case 'D': v+=13*x; break;
	case 'E': v+=14*x; break;
	case 'F': v+=15*x; break;
	default: yyerror("Not at hex number\n");
      }
      x=x*16;
    }

  return v;
}


